import com.tinkerforge.BrickletRotaryPoti;
import com.tinkerforge.IPConnection;

public class ExampleSimple {
	private static final String host = new String("localhost");
	private static final int port = 4223;
	private static final String UID = new String("ABC"); // Change to your UID
	
	// Note: To make the example code cleaner we do not handle exceptions. Exceptions you
	//       might normally want to catch are described in the commnents below
	public static void main(String args[]) throws Exception {
		// Create connection to brickd
		IPConnection ipcon = new IPConnection(host, port); // Can throw IOException

		BrickletRotaryPoti rp = new BrickletRotaryPoti(UID); // Create device object

		// Add device to ip connection
		ipcon.addDevice(rp); // Can throw IPConnection.TimeoutException
		// Don't use device before it is added to a connection
		

		// Get current position (return value has range -150 to 150)
		short position = rp.getPosition(); // Can throw IPConnection.TimeoutException

		System.out.println("Position: " + position);
		
		System.out.println("Press ctrl+c to exit");
		ipcon.joinThread();
	}
}
